<template>
  <Error v-if="$fetchState.error" :error="$fetchState.error"></Error>
  <BaseBoard v-else :pretitle="project.title">
    <template #title-board>
      <h3
        class="page-title"
        data-hint="Explore your scenario"
        data-hintposition="top-left"
      >
        {{ scenario.title || scenario.name }}
      </h3>
    </template>
    <template #header-right>
      <div class="justify-content-start">
        <ul class="nav nav-tabs nav-tabs-project border-bottom-0">
          <li class="nav-item">
            <NuxtLink
              :to="tabLinks.configure"
              class="nav-link nav-link-toggle-board"
              :class="{ active: isActive('configure') }"
            >
              <AdjustmentsIcon class="mr-2" />
              Configuration
            </NuxtLink>
          </li>
          <li class="nav-item">
            <NuxtLink
              :to="tabLinks.documentation"
              class="nav-link nav-link-toggle-board"
              :class="{ active: isActive('documentation') }"
            >
              <FileTextIcon class="mr-2" />
              Documentation
            </NuxtLink>
          </li>
          <li class="nav-toggle nav-item ml-auto">
            <div class="btn-list">
              <div class="d-none d-sm-inline">
                <NuxtLink
                  data-cy="btn-back-to-project"
                  class="btn"
                  :to="`/projects/${projectId}/view`"
                >
                  <ArrowLeftIcon />Back to project
                </NuxtLink>
              </div>
              <a
                data-cy="btn-run-scenario"
                class="btn btn-primary d-none d-sm-inline-block"
                :class="{
                  disabled:
                    $fetchState.pending ||
                    hasError ||
                    waiting ||
                    project.state.slug === 'running',
                }"
                @click="runScenario"
              >
                <PlayerPlayIcon v-if="project.state.slug !== 'running'" />
                <b-spinner
                  v-else
                  style="width: 1rem; height: 1rem; color: white"
                ></b-spinner>
                {{ buttonMessage }}
              </a>
              <a
                v-if="isRunning"
                class="btn btn-primary d-none d-sm-inline-block"
                @click="stopScenario"
              >
                <PlayerStopIcon />
                Stop
              </a>
            </div>
          </li>
        </ul>
      </div>
    </template>
    <template #content>
      <!-- for row in row  -->
      <div class="col">
        <NuxtChild :loading="$fetchState.pending" />
      </div>
    </template>
  </BaseBoard>
</template>

<script>
import notificationsMixin from '~/mixins/notifications.js';
import helpersMixin from '~/mixins/helpers.js';
const tabs = {
  configure: 'projects-id-configure-scenarioId',
  documentation: 'projects-id-configure-scenarioId-documentation',
};

export default {
  mixins: [notificationsMixin, helpersMixin],
  layout: 'dashboard',
  middleware: 'auth',
  data() {
    return {
      waiting: false,
      projectId: this.$nuxt.$route.params.id,
      scenarioId: this.$nuxt.$route.params.scenarioId,
    };
  },
  async fetch() {
    const projectId = this.$nuxt.$route.params.id;
    const scenarioId = this.$nuxt.$route.params.scenarioId;
    const store = this.$nuxt.context.store;
    await this.$nuxt.context.store.dispatch('presets/getPresets', {
      scenarioId,
    });
    this.$nuxt.context.store.commit('presets/setUserPreset', null);
    await store.dispatch('projects/fetchProjectSummary', {
      id: projectId,
    });
    await store.dispatch('scenarios/fetchProjectScenarios', {
      projectId,
    });
    store.dispatch('projects/setTitleLastJobScenario', {
      projectId,
      scenarioId,
    });
    await store.dispatch('parameters/loadParameters', {
      projectId,
      scenarioId,
    });
    const inputMap = store.state.parameters.inputMap;
    const containsDatasetInput = Object.values(inputMap).find(
      (input) => input.type === 'string+dataset-id'
    );
    if (containsDatasetInput) {
      await store.dispatch('datasets/fetchProjectDatasets', {
        projectId,
      });
    }
  },
  head() {
    return {
      title: 'Projects - RISIS Workspace',
    };
  },
  computed: {
    project() {
      return this.$store.getters['projects/singleProject'](this.projectId);
    },
    scenario() {
      return this.$store.getters['scenarios/singleScenario'](this.scenarioId);
    },
    tabLinks() {
      return {
        configure: `/projects/${this.projectId}/configure/${this.scenarioId}`,
        documentation: `/projects/${this.projectId}/configure/${this.scenarioId}/documentation`,
      };
    },
    hasError() {
      return this.$store.getters['scenarios/hasError'](this.scenarioId);
    },
    buttonMessage() {
      if (this.waiting) {
        return 'Waiting...';
      } else if (this.project.state.slug === 'running') {
        return 'Running...';
      }
      return 'Run this scenario';
    },
    isRunning() {
      const runningScenario = this.$store.getters[
        'projects/projectRunningScenario'
      ](this.projectId);
      return this.scenarioId === runningScenario.id;
    },
  },
  methods: {
    isActive(tabKey) {
      return this.$nuxt.$route.name === tabs[tabKey];
    },
    async stopScenario() {
      if (this.isRunning) {
        await this.$nuxt.context.store.dispatch('scenarios/stopScenario', {
          projectId: this.projectId,
          scenarioId: this.scenarioId,
        });
      }
    },
    async runScenario() {
      if (this.project.state.slug !== 'running') {
        this.waiting = true;
        await this.wait(1000);
        for (let i = 0; i < 30; i++) {
          const configsOnQueue = this.$nuxt.context.store.getters[
            'parameters/configsOnQueue'
          ](this.projectId, this.scenarioId);
          if (!configsOnQueue || configsOnQueue.length === 0) {
            this.showNotification(
              `The scenario ${this.scenario.title} is running!`,
              'Running!'
            );
            this.$nuxt.context.store.commit('projects/setJobTitle', '');
            await this.$nuxt.context.store.dispatch('scenarios/runScenario', {
              projectId: this.projectId,
              scenarioId: this.scenarioId,
            });
            await this.$nuxt.context.store.dispatch(
              'projects/fetchSingleProject',
              {
                id: this.projectId,
              }
            );
            this.waiting = false;
            break;
          } else if (configsOnQueue.map((e) => e.status).includes('error')) {
            this.$nuxt.context.store.dispatch(
              'parameters/removeErrorUpdatingConfig',
              {
                projectId: this.projectId,
                scenarioId: this.scenarioId,
              }
            );
            this.waiting = false;
            break;
          } else if (i === 30) {
            this.showErrorNotification(
              'Error saving configuration, It takes more than 30 seconds'
            );
            this.waiting = false;
            break;
          }
          await this.wait(1000);
        }
      }
    },
  },
};
</script>
